\documentclass[12pt,a4paper]{article}
\renewcommand{\familydefault}{\sfdefault}

\usepackage{listings}
\usepackage{xcolor}
\usepackage{enumitem}
\usepackage{nameref}

\begin{document}
\author{Benjamin Komar}
\title{Winner}
\date{28. Dec. 2019}
\maketitle
\newpage
\tableofcontents
\newpage

\section{Introduction}
    This is a documentation for the project Winner which is written in the programming language Java with the JavaFX-Framework.
    
\section{What is Winner?}
    Winner is a program that is used to do ER-Modelling with as little effort as possible
    
\section{Functionality}    
    \subsection{Creating ER-models}
        You are able to create any ER-Model using either the built-in text-editor or add ER-Elements one after another by a GUI-Based Design.
        This program makes creating these models quite easy as it has a 'What you write is what you get' concept.

    \subsection{Export/Import}
        \subsubsection{Export}
            Textrepresentation [.er], Picture [.png]

        \subsubsection{Import}
            Textrepresentation [.er]

    \subsection{Styling}
        Any styling can either be done individually (= a specific style per ER-Element)
        or globally (= a default style, for every ER-Element)

\newpage
\section{Code-Base | Documentation}

This big chunk is dedicated to the documentation of our code; explaining everything that has been done so far and will be done in the future.

    \subsection{Lombok}
        To begin with, let's start with the very useful library/plugin called 'Lombok'.
        With Lombok you can add code-changing Annotations in certain spots in your code
        so that a lot of boiler code (e.g.: Getters, Setters, Constructors, ToString, Equals/Hashcode, ...)
        can simply be auto-generated in a way, so that it is not visible in the actual code. This keeps
        the code in the individually classes clean and allows you to only see the code that actually does something important.
        \newline
        The most used Annotations are:
        \begin{itemize}[align=left]
            \item[@Getter:] Creates Getters
            \item[@Settter:] Creates Setters
            \item[@ToString:] Creates ToString
            \item[@AllArgsConstructor:] Creates a constructor with every parameter/variable in it.
            \item[@Data:] Does all of the above and more!
        \end{itemize}

    \subsection{Event-System}
        \subsubsection{What is an Event?}
        Before we can get into the details of all the classes in the code, let's start with the so-called \emph{Event-System}
        

        The event system has its roots from the super-basic interface \emph{Event}, which is simply an empty interface which implements any class that
        should be an Event.
        
        An example of such a class is listed below:

        \colorbox
        {lightgray}
        {
            \lstinputlisting[language=Java]
            {../src/main/java/org/zeichner/winner/ui/fields/event/ERCreateEvent.java}
        }

        \subsubsection{Why do we need an Event-System?}
        Technically\dots we don't.
        The Event-System fullfills one - important - purpose: 
        \begin{center}
            \underline{\LARGE{ORGANIZATION}}
        \end{center}
        *ähem*, anyways\dots

        The Event-System goes hand-in-hand with our \emph{Dispatcher} and \emph{Field} classes in the following way:
        \begin{enumerate}[align=left]
            \item Whenever somebody (we will talk about that somebody later, see section \ref{sec:Field-System} \nameref{sec:Field-System})
            does something that might be interesting for others as well, then it will broadcast whatever Event it has done (with some data, so others can work with that).
            \item In order to broadcast that Event, the Dispatcher comes into play as it will simply ask everyone it knows of if they \\
            are interested in the given Event (except for the sender of course).
            \linebreak The Dispatcher is called by the static method \emph{Dispatcher.send(Event event)}
            \linebreak When the Dispatcher gets called, it messages everyone (except the sender) with the method \emph{field.areYouInterestedInEvent(Event event)}
            \item Each reciever then checks if their list of "interested-Events" if the Event they just recieved is in this list (no matter what exact information is contained in the Event)
            \item When somebody is interested in the Event, it will execute a certain method linked to that Event, when not it simply ignores the Event.
        \end{enumerate}


    \subsection{Field-System}
        \label{sec:Field-System}
    

    
\end{document}